install.sh 13 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334335336337338339340341342343344345346347348349350351352353354355356357358359360361362363364365366367368369370371372373
  1. #!/bin/sh
  2. # This script installs Ollama on Linux.
  3. # It detects the current operating system architecture and installs the appropriate version of Ollama.
  4. set -eu
  5. red="$( (/usr/bin/tput bold || :; /usr/bin/tput setaf 1 || :) 2>&-)"
  6. plain="$( (/usr/bin/tput sgr0 || :) 2>&-)"
  7. status() { echo ">>> $*" >&2; }
  8. error() { echo "${red}ERROR:${plain} $*"; exit 1; }
  9. warning() { echo "${red}WARNING:${plain} $*"; }
  10. TEMP_DIR=$(mktemp -d)
  11. cleanup() { rm -rf $TEMP_DIR; }
  12. trap cleanup EXIT
  13. available() { command -v $1 >/dev/null; }
  14. require() {
  15. local MISSING=''
  16. for TOOL in $*; do
  17. if ! available $TOOL; then
  18. MISSING="$MISSING $TOOL"
  19. fi
  20. done
  21. echo $MISSING
  22. }
  23. [ "$(uname -s)" = "Linux" ] || error 'This script is intended to run on Linux only.'
  24. ARCH=$(uname -m)
  25. case "$ARCH" in
  26. x86_64) ARCH="amd64" ;;
  27. aarch64|arm64) ARCH="arm64" ;;
  28. *) error "Unsupported architecture: $ARCH" ;;
  29. esac
  30. IS_WSL2=false
  31. KERN=$(uname -r)
  32. case "$KERN" in
  33. *icrosoft*WSL2 | *icrosoft*wsl2) IS_WSL2=true;;
  34. *icrosoft) error "Microsoft WSL1 is not currently supported. Please use WSL2 with 'wsl --set-version <distro> 2'" ;;
  35. *) ;;
  36. esac
  37. VER_PARAM="${OLLAMA_VERSION:+?version=$OLLAMA_VERSION}"
  38. SUDO=
  39. if [ "$(id -u)" -ne 0 ]; then
  40. # Running as root, no need for sudo
  41. if ! available sudo; then
  42. error "This script requires superuser permissions. Please re-run as root."
  43. fi
  44. SUDO="sudo"
  45. fi
  46. NEEDS=$(require curl awk grep sed tee xargs)
  47. if [ -n "$NEEDS" ]; then
  48. status "ERROR: The following tools are required but missing:"
  49. for NEED in $NEEDS; do
  50. echo " - $NEED"
  51. done
  52. exit 1
  53. fi
  54. for BINDIR in /usr/local/bin /usr/bin /bin; do
  55. echo $PATH | grep -q $BINDIR && break || continue
  56. done
  57. OLLAMA_INSTALL_DIR=$(dirname ${BINDIR})
  58. if [ -d "$OLLAMA_INSTALL_DIR/lib/ollama" ] ; then
  59. status "Cleaning up old version at $OLLAMA_INSTALL_DIR/lib/ollama"
  60. $SUDO rm -rf "$OLLAMA_INSTALL_DIR/lib/ollama"
  61. fi
  62. status "Installing ollama to $OLLAMA_INSTALL_DIR"
  63. $SUDO install -o0 -g0 -m755 -d $BINDIR
  64. $SUDO install -o0 -g0 -m755 -d "$OLLAMA_INSTALL_DIR"
  65. status "Downloading Linux ${ARCH} bundle"
  66. curl --fail --show-error --location --progress-bar \
  67. "https://ollama.com/download/ollama-linux-${ARCH}.tgz${VER_PARAM}" | \
  68. $SUDO tar -xzf - -C "$OLLAMA_INSTALL_DIR"
  69. if [ "$OLLAMA_INSTALL_DIR/bin/ollama" != "$BINDIR/ollama" ] ; then
  70. status "Making ollama accessible in the PATH in $BINDIR"
  71. $SUDO ln -sf "$OLLAMA_INSTALL_DIR/ollama" "$BINDIR/ollama"
  72. fi
  73. # Check for NVIDIA JetPack systems with additional downloads
  74. if [ -f /etc/nv_tegra_release ] ; then
  75. if grep R36 /etc/nv_tegra_release > /dev/null ; then
  76. status "Downloading JetPack 6 components"
  77. curl --fail --show-error --location --progress-bar \
  78. "https://ollama.com/download/ollama-linux-${ARCH}-jetpack6.tgz${VER_PARAM}" | \
  79. $SUDO tar -xzf - -C "$OLLAMA_INSTALL_DIR"
  80. elif grep R35 /etc/nv_tegra_release > /dev/null ; then
  81. status "Downloading JetPack 5 components"
  82. curl --fail --show-error --location --progress-bar \
  83. "https://ollama.com/download/ollama-linux-${ARCH}-jetpack5.tgz${VER_PARAM}" | \
  84. $SUDO tar -xzf - -C "$OLLAMA_INSTALL_DIR"
  85. else
  86. warning "Unsupported JetPack version detected. GPU may not be supported"
  87. fi
  88. fi
  89. install_success() {
  90. status 'The Ollama API is now available at 127.0.0.1:11434.'
  91. status 'Install complete. Run "ollama" from the command line.'
  92. }
  93. trap install_success EXIT
  94. # Everything from this point onwards is optional.
  95. configure_systemd() {
  96. if ! id ollama >/dev/null 2>&1; then
  97. status "Creating ollama user..."
  98. $SUDO useradd -r -s /bin/false -U -m -d /usr/share/ollama ollama
  99. fi
  100. if getent group render >/dev/null 2>&1; then
  101. status "Adding ollama user to render group..."
  102. $SUDO usermod -a -G render ollama
  103. fi
  104. if getent group video >/dev/null 2>&1; then
  105. status "Adding ollama user to video group..."
  106. $SUDO usermod -a -G video ollama
  107. fi
  108. status "Adding current user to ollama group..."
  109. $SUDO usermod -a -G ollama $(whoami)
  110. status "Creating ollama systemd service..."
  111. cat <<EOF | $SUDO tee /etc/systemd/system/ollama.service >/dev/null
  112. [Unit]
  113. Description=Ollama Service
  114. After=network-online.target
  115. [Service]
  116. ExecStart=$BINDIR/ollama serve
  117. User=ollama
  118. Group=ollama
  119. Restart=always
  120. RestartSec=3
  121. Environment="PATH=$PATH"
  122. [Install]
  123. WantedBy=default.target
  124. EOF
  125. SYSTEMCTL_RUNNING="$(systemctl is-system-running || true)"
  126. case $SYSTEMCTL_RUNNING in
  127. running|degraded)
  128. status "Enabling and starting ollama service..."
  129. $SUDO systemctl daemon-reload
  130. $SUDO systemctl enable ollama
  131. start_service() { $SUDO systemctl restart ollama; }
  132. trap start_service EXIT
  133. ;;
  134. *)
  135. warning "systemd is not running"
  136. if [ "$IS_WSL2" = true ]; then
  137. warning "see https://learn.microsoft.com/en-us/windows/wsl/systemd#how-to-enable-systemd to enable it"
  138. fi
  139. ;;
  140. esac
  141. }
  142. if available systemctl; then
  143. configure_systemd
  144. fi
  145. # WSL2 only supports GPUs via nvidia passthrough
  146. # so check for nvidia-smi to determine if GPU is available
  147. if [ "$IS_WSL2" = true ]; then
  148. if available nvidia-smi && [ -n "$(nvidia-smi | grep -o "CUDA Version: [0-9]*\.[0-9]*")" ]; then
  149. status "Nvidia GPU detected."
  150. fi
  151. install_success
  152. exit 0
  153. fi
  154. # Don't attempt to install drivers on Jetson systems
  155. if [ -f /etc/nv_tegra_release ] ; then
  156. status "NVIDIA JetPack ready."
  157. install_success
  158. exit 0
  159. fi
  160. # Install GPU dependencies on Linux
  161. if ! available lspci && ! available lshw; then
  162. warning "Unable to detect NVIDIA/AMD GPU. Install lspci or lshw to automatically detect and install GPU dependencies."
  163. exit 0
  164. fi
  165. check_gpu() {
  166. # Look for devices based on vendor ID for NVIDIA and AMD
  167. case $1 in
  168. lspci)
  169. case $2 in
  170. nvidia) available lspci && lspci -d '10de:' | grep -q 'NVIDIA' || return 1 ;;
  171. amdgpu) available lspci && lspci -d '1002:' | grep -q 'AMD' || return 1 ;;
  172. esac ;;
  173. lshw)
  174. case $2 in
  175. nvidia) available lshw && $SUDO lshw -c display -numeric -disable network | grep -q 'vendor: .* \[10DE\]' || return 1 ;;
  176. amdgpu) available lshw && $SUDO lshw -c display -numeric -disable network | grep -q 'vendor: .* \[1002\]' || return 1 ;;
  177. esac ;;
  178. nvidia-smi) available nvidia-smi || return 1 ;;
  179. esac
  180. }
  181. if check_gpu nvidia-smi; then
  182. status "NVIDIA GPU installed."
  183. exit 0
  184. fi
  185. if ! check_gpu lspci nvidia && ! check_gpu lshw nvidia && ! check_gpu lspci amdgpu && ! check_gpu lshw amdgpu; then
  186. install_success
  187. warning "No NVIDIA/AMD GPU detected. Ollama will run in CPU-only mode."
  188. exit 0
  189. fi
  190. if check_gpu lspci amdgpu || check_gpu lshw amdgpu; then
  191. status "Downloading Linux ROCm ${ARCH} bundle"
  192. curl --fail --show-error --location --progress-bar \
  193. "https://ollama.com/download/ollama-linux-${ARCH}-rocm.tgz${VER_PARAM}" | \
  194. $SUDO tar -xzf - -C "$OLLAMA_INSTALL_DIR"
  195. install_success
  196. status "AMD GPU ready."
  197. exit 0
  198. fi
  199. CUDA_REPO_ERR_MSG="NVIDIA GPU detected, but your OS and Architecture are not supported by NVIDIA. Please install the CUDA driver manually https://docs.nvidia.com/cuda/cuda-installation-guide-linux/"
  200. # ref: https://docs.nvidia.com/cuda/cuda-installation-guide-linux/index.html#rhel-7-centos-7
  201. # ref: https://docs.nvidia.com/cuda/cuda-installation-guide-linux/index.html#rhel-8-rocky-8
  202. # ref: https://docs.nvidia.com/cuda/cuda-installation-guide-linux/index.html#rhel-9-rocky-9
  203. # ref: https://docs.nvidia.com/cuda/cuda-installation-guide-linux/index.html#fedora
  204. install_cuda_driver_yum() {
  205. status 'Installing NVIDIA repository...'
  206. case $PACKAGE_MANAGER in
  207. yum)
  208. $SUDO $PACKAGE_MANAGER -y install yum-utils
  209. if curl -I --silent --fail --location "https://developer.download.nvidia.com/compute/cuda/repos/$1$2/$(uname -m | sed -e 's/aarch64/sbsa/')/cuda-$1$2.repo" >/dev/null ; then
  210. $SUDO $PACKAGE_MANAGER-config-manager --add-repo https://developer.download.nvidia.com/compute/cuda/repos/$1$2/$(uname -m | sed -e 's/aarch64/sbsa/')/cuda-$1$2.repo
  211. else
  212. error $CUDA_REPO_ERR_MSG
  213. fi
  214. ;;
  215. dnf)
  216. if curl -I --silent --fail --location "https://developer.download.nvidia.com/compute/cuda/repos/$1$2/$(uname -m | sed -e 's/aarch64/sbsa/')/cuda-$1$2.repo" >/dev/null ; then
  217. $SUDO $PACKAGE_MANAGER config-manager --add-repo https://developer.download.nvidia.com/compute/cuda/repos/$1$2/$(uname -m | sed -e 's/aarch64/sbsa/')/cuda-$1$2.repo
  218. else
  219. error $CUDA_REPO_ERR_MSG
  220. fi
  221. ;;
  222. esac
  223. case $1 in
  224. rhel)
  225. status 'Installing EPEL repository...'
  226. # EPEL is required for third-party dependencies such as dkms and libvdpau
  227. $SUDO $PACKAGE_MANAGER -y install https://dl.fedoraproject.org/pub/epel/epel-release-latest-$2.noarch.rpm || true
  228. ;;
  229. esac
  230. status 'Installing CUDA driver...'
  231. if [ "$1" = 'centos' ] || [ "$1$2" = 'rhel7' ]; then
  232. $SUDO $PACKAGE_MANAGER -y install nvidia-driver-latest-dkms
  233. fi
  234. $SUDO $PACKAGE_MANAGER -y install cuda-drivers
  235. }
  236. # ref: https://docs.nvidia.com/cuda/cuda-installation-guide-linux/index.html#ubuntu
  237. # ref: https://docs.nvidia.com/cuda/cuda-installation-guide-linux/index.html#debian
  238. install_cuda_driver_apt() {
  239. status 'Installing NVIDIA repository...'
  240. if curl -I --silent --fail --location "https://developer.download.nvidia.com/compute/cuda/repos/$1$2/$(uname -m | sed -e 's/aarch64/sbsa/')/cuda-keyring_1.1-1_all.deb" >/dev/null ; then
  241. curl -fsSL -o $TEMP_DIR/cuda-keyring.deb https://developer.download.nvidia.com/compute/cuda/repos/$1$2/$(uname -m | sed -e 's/aarch64/sbsa/')/cuda-keyring_1.1-1_all.deb
  242. else
  243. error $CUDA_REPO_ERR_MSG
  244. fi
  245. case $1 in
  246. debian)
  247. status 'Enabling contrib sources...'
  248. $SUDO sed 's/main/contrib/' < /etc/apt/sources.list | $SUDO tee /etc/apt/sources.list.d/contrib.list > /dev/null
  249. if [ -f "/etc/apt/sources.list.d/debian.sources" ]; then
  250. $SUDO sed 's/main/contrib/' < /etc/apt/sources.list.d/debian.sources | $SUDO tee /etc/apt/sources.list.d/contrib.sources > /dev/null
  251. fi
  252. ;;
  253. esac
  254. status 'Installing CUDA driver...'
  255. $SUDO dpkg -i $TEMP_DIR/cuda-keyring.deb
  256. $SUDO apt-get update
  257. [ -n "$SUDO" ] && SUDO_E="$SUDO -E" || SUDO_E=
  258. DEBIAN_FRONTEND=noninteractive $SUDO_E apt-get -y install cuda-drivers -q
  259. }
  260. if [ ! -f "/etc/os-release" ]; then
  261. error "Unknown distribution. Skipping CUDA installation."
  262. fi
  263. . /etc/os-release
  264. OS_NAME=$ID
  265. OS_VERSION=$VERSION_ID
  266. PACKAGE_MANAGER=
  267. for PACKAGE_MANAGER in dnf yum apt-get; do
  268. if available $PACKAGE_MANAGER; then
  269. break
  270. fi
  271. done
  272. if [ -z "$PACKAGE_MANAGER" ]; then
  273. error "Unknown package manager. Skipping CUDA installation."
  274. fi
  275. if ! check_gpu nvidia-smi || [ -z "$(nvidia-smi | grep -o "CUDA Version: [0-9]*\.[0-9]*")" ]; then
  276. case $OS_NAME in
  277. centos|rhel) install_cuda_driver_yum 'rhel' $(echo $OS_VERSION | cut -d '.' -f 1) ;;
  278. rocky) install_cuda_driver_yum 'rhel' $(echo $OS_VERSION | cut -c1) ;;
  279. fedora) [ $OS_VERSION -lt '39' ] && install_cuda_driver_yum $OS_NAME $OS_VERSION || install_cuda_driver_yum $OS_NAME '39';;
  280. amzn) install_cuda_driver_yum 'fedora' '37' ;;
  281. debian) install_cuda_driver_apt $OS_NAME $OS_VERSION ;;
  282. ubuntu) install_cuda_driver_apt $OS_NAME $(echo $OS_VERSION | sed 's/\.//') ;;
  283. *) exit ;;
  284. esac
  285. fi
  286. if ! lsmod | grep -q nvidia || ! lsmod | grep -q nvidia_uvm; then
  287. KERNEL_RELEASE="$(uname -r)"
  288. case $OS_NAME in
  289. rocky) $SUDO $PACKAGE_MANAGER -y install kernel-devel kernel-headers ;;
  290. centos|rhel|amzn) $SUDO $PACKAGE_MANAGER -y install kernel-devel-$KERNEL_RELEASE kernel-headers-$KERNEL_RELEASE ;;
  291. fedora) $SUDO $PACKAGE_MANAGER -y install kernel-devel-$KERNEL_RELEASE ;;
  292. debian|ubuntu) $SUDO apt-get -y install linux-headers-$KERNEL_RELEASE ;;
  293. *) exit ;;
  294. esac
  295. NVIDIA_CUDA_VERSION=$($SUDO dkms status | awk -F: '/added/ { print $1 }')
  296. if [ -n "$NVIDIA_CUDA_VERSION" ]; then
  297. $SUDO dkms install $NVIDIA_CUDA_VERSION
  298. fi
  299. if lsmod | grep -q nouveau; then
  300. status 'Reboot to complete NVIDIA CUDA driver install.'
  301. exit 0
  302. fi
  303. $SUDO modprobe nvidia
  304. $SUDO modprobe nvidia_uvm
  305. fi
  306. # make sure the NVIDIA modules are loaded on boot with nvidia-persistenced
  307. if available nvidia-persistenced; then
  308. $SUDO touch /etc/modules-load.d/nvidia.conf
  309. MODULES="nvidia nvidia-uvm"
  310. for MODULE in $MODULES; do
  311. if ! grep -qxF "$MODULE" /etc/modules-load.d/nvidia.conf; then
  312. echo "$MODULE" | $SUDO tee -a /etc/modules-load.d/nvidia.conf > /dev/null
  313. fi
  314. done
  315. fi
  316. status "NVIDIA GPU ready."
  317. install_success